from tkinter import *
import math
import copy
import types
from threeD import *
root= Tk()
root.title("3D Methods(painter's alogolism)")
canvas=Canvas(root,width=500,height=400)
canvas.pack()
init2D(500,400)
origin(250,200)
V0= Point(500,500,500) #視点
L0= Point(0,500,1000)  #照明光
setview(V0)
#drawAxisXYZ(canvas)
a=circle_xz(18)         #トーラスの原型(円)
aa=a*50
b=circle_xy(36)         #円形(補助線用)
f=revolve_z(move(100,0,0)*aa,36)
NN=len(f.polygon)

d=[0 for i in range(NN)]
s=[0 for i in range(NN)]
#視点とポリゴンの距離計算
for j in range(NN):
    p=f.polygon[j]
    d[j]=length(V0-(p.p[0]+p.p[1]+p.p[2]+p.p[3])/4)
    s[j]=j
#視点とポリゴンの距離が大きい順に並べる（バブルソート）
for k in range(NN-1):
    for i in range(NN-1):
        if(d[i]<d[i+1]):
            DD=d[i];d[i]=d[i+1];d[i+1]=DD
            SS=s[i];s[i]=s[i+1];s[i+1]=SS
#描画
for i in range(NN):
    p=f.polygon[s[i]]
    N=unit((p.p[0]-p.p[2])%(p.p[1]-p.p[3]));
    D=(((N)*L0))/(length(N)*length(L0))
    if(D<0) :D=0
    elif(D>1):D=1
    X= int(D*255)
    C="#%02X%02X%02X" %(X,X,X)
    paintPolygon(canvas, p,C)
#drawLine(canvas,move(100,0,0)*aa, 'red')
#drawLine(canvas,b*150, 'red');
